SystemOrganization addCategory: #'Magritte-Chronos-Description'!
SystemOrganization addCategory: #'Magritte-Chronos-Tests'!

!MAVisitor methodsFor: '*Magritte-Chronos' stamp: 'pmm 10/20/2006 21:42'!
visitChronosDescription: aChronosDescription
	self visitMagnitudeDescription: aChronosDescription! !

!MAVisitor methodsFor: '*Magritte-Chronos' stamp: 'pmm 10/20/2006 21:43'!
visitScientificDurationDescription: aScientificDurationDescription
	self visitChronosDescription: aScientificDurationDescription! !

!MAVisitor methodsFor: '*Magritte-Chronos' stamp: 'pmm 10/20/2006 21:44'!
visitTimeOfDayDescription: aTimeOfDayDescription
	self visitChronosDescription: aTimeOfDayDescription! !

!MAVisitor methodsFor: '*Magritte-Chronos' stamp: 'pmm 10/20/2006 21:43'!
visitTimepointDescription: aTimepointDescription
	self visitChronosDescription: aTimepointDescription! !

!MAVisitor methodsFor: '*Magritte-Chronos' stamp: 'pmm 10/20/2006 21:44'!
visitYearMonthDayDescription: aYearMonthDayDescription
	self visitChronosDescription: aYearMonthDayDescription! !

!MAStringReader methodsFor: '*Magritte-Chronos' stamp: 'pmm 10/20/2006 22:56'!
visitChronosDescription: aChronosDescription
	"doesn't work for all Chronos descriptions :("
	"self object: (aChronosDescription kind
		readFrom: self stream
		using: aChronosDescription parser)"
	self visitMagnitudeDescription: aChronosDescription! !

!MAStringReader methodsFor: '*Magritte-Chronos' stamp: 'pmm 10/20/2006 22:55'!
visitTimeOfDayDescription: aChronosDescription
	self object: (aChronosDescription kind
		readFrom: self stream
		using: aChronosDescription parser)! !

!MAStringReader methodsFor: '*Magritte-Chronos' stamp: 'pmm 10/20/2006 22:55'!
visitTimepointDescription: aChronosDescription
	self object: (aChronosDescription kind
		readFrom: self stream
		using: aChronosDescription parser)! !

MAMagnitudeDescription subclass: #CHChronosDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Description'!

!CHChronosDescription commentStamp: 'pmm 10/20/2006 22:42' prior: 0!
A CHChronosDescription is the superclass of all Chronos descriptions.!

!CHChronosDescription class methodsFor: 'accessing-defaults' stamp: 'pmm 10/20/2006 22:58'!
defaultParser
	^ ChronosParser iso8601! !

!CHChronosDescription class methodsFor: 'accessing-defaults' stamp: 'pmm 10/20/2006 21:51'!
defaultPrintPolicy
	^ ChronosPrintPolicy ansiStandard! !

!CHChronosDescription methodsFor: 'visiting' stamp: 'pmm 10/20/2006 22:40'!
acceptMagritte: aVisitor
	aVisitor visitChronosDescription: self! !

!CHChronosDescription methodsFor: 'accessing-configuration' stamp: 'pmm 10/20/2006 21:54'!
parser
	^ self
		propertyAt: #parser
		ifAbsent: [ self class defaultParser ]! !

!CHChronosDescription methodsFor: 'accessing-configuration' stamp: 'pmm 10/20/2006 21:54'!
printPolicy
	^ self
		propertyAt: #printPolicy
		ifAbsent: [ self class defaultPrintPolicy ]! !

CHChronosDescription subclass: #CHScientificDurationDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Description'!

!CHScientificDurationDescription commentStamp: 'pmm 10/20/2006 22:42' prior: 0!
A CHScientificDurationDescription is the Chronos version of MADurationDescription.!

!CHScientificDurationDescription class methodsFor: 'testing' stamp: 'pmm 10/20/2006 21:15'!
isAbstract
	^ false! !

!CHScientificDurationDescription class methodsFor: 'accessing' stamp: 'pmm 10/20/2006 21:15'!
label
	^ MADurationDescription label! !

!CHScientificDurationDescription methodsFor: 'visiting' stamp: 'pmm 10/20/2006 21:45'!
acceptMagritte: aVisitor
	aVisitor visitScientificDurationDescription: self! !

!CHScientificDurationDescription methodsFor: 'accessing' stamp: 'pmm 10/20/2006 21:59'!
kind
	^ ScientificDuration! !

CHChronosDescription subclass: #CHTimeOfDayDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Description'!

!CHTimeOfDayDescription commentStamp: 'pmm 10/20/2006 22:43' prior: 0!
A CHTimeOfDayDescription is the Chronos version of MATimeDescription.!

!CHTimeOfDayDescription class methodsFor: 'testing' stamp: 'pmm 10/20/2006 21:17'!
isAbstract
	^ false! !

!CHTimeOfDayDescription class methodsFor: 'accessing' stamp: 'pmm 10/20/2006 21:39'!
label
	^ MATimeDescription label! !

!CHTimeOfDayDescription methodsFor: 'visiting' stamp: 'pmm 10/20/2006 21:45'!
acceptMagritte: aVisitor
	aVisitor visitTimeOfDayDescription: self! !

!CHTimeOfDayDescription methodsFor: 'accessing' stamp: 'pmm 10/20/2006 21:59'!
kind
	^ TimeOfDay! !

CHChronosDescription subclass: #CHTimepointDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Description'!

!CHTimepointDescription commentStamp: 'pmm 10/20/2006 22:43' prior: 0!
A CHTimepointDescription is the Chronos version of MATimeStampDescription.
!

!CHTimepointDescription class methodsFor: 'testing' stamp: 'pmm 10/20/2006 22:40'!
isAbstract
	^ false! !

!CHTimepointDescription class methodsFor: 'accessing' stamp: 'pmm 10/20/2006 22:40'!
label
	^ MATimeStampDescription label! !

!CHTimepointDescription methodsFor: 'visiting' stamp: 'pmm 10/20/2006 22:41'!
acceptMagritte: aVisitor
	aVisitor visitTimepointDescription: self! !

!CHTimepointDescription methodsFor: 'accessing' stamp: 'pmm 10/20/2006 22:40'!
kind
	^ Timepoint! !

CHChronosDescription subclass: #CHYearMonthDayDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Description'!

!CHYearMonthDayDescription commentStamp: 'pmm 10/20/2006 22:43' prior: 0!
A CHYearMonthDayDescription is the Chronos version of MADateDescription.!

!CHYearMonthDayDescription class methodsFor: 'testing' stamp: 'pmm 10/20/2006 22:41'!
isAbstract
	^ false! !

!CHYearMonthDayDescription class methodsFor: 'accessing' stamp: 'pmm 10/20/2006 22:42'!
label
	^ MADateDescription label! !

!CHYearMonthDayDescription methodsFor: 'visiting' stamp: 'pmm 10/20/2006 22:41'!
acceptMagritte: aVisitor
	aVisitor visitYearMonthDayDescription: self! !

!CHYearMonthDayDescription methodsFor: 'accessing' stamp: 'pmm 10/20/2006 22:41'!
kind
	^ YearMonthDay! !

MAMagnitudeDescriptionTest subclass: #CHChronosDescriptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Tests'!

CHChronosDescriptionTest subclass: #CHScientificDurationDescriptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Tests'!

!CHScientificDurationDescriptionTest class methodsFor: 'testing' stamp: 'pmm 10/20/2006 22:46'!
isAbstract
	^ false! !

!CHScientificDurationDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:05'!
actualClass
	^ CHScientificDurationDescription ! !

!CHScientificDurationDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:05'!
includedInstance
	^ ScientificDuration days: 1 hours: 2 minutes: 3 seconds: 4! !

!CHScientificDurationDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:05'!
maxInstance
	^ ScientificDuration days: 2 hours: 2 minutes: 3 seconds: 4! !

!CHScientificDurationDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:05'!
minInstance
	^ ScientificDuration days: 0 hours: 2 minutes: 3 seconds: 4! !

CHChronosDescriptionTest subclass: #CHTimeOfDayDescriptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Tests'!

!CHTimeOfDayDescriptionTest class methodsFor: 'testing' stamp: 'pmm 10/20/2006 22:01'!
isAbstract
	^ false! !

!CHTimeOfDayDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:05'!
actualClass
	^ CHTimeOfDayDescription! !

!CHTimeOfDayDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:06'!
includedInstance
	^ TimeOfDay hour: 11 minute: 33 second: 12! !

!CHTimeOfDayDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:06'!
maxInstance
	^ TimeOfDay hour: 12 minute: 33 second: 12! !

!CHTimeOfDayDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:06'!
minInstance
	^ TimeOfDay hour: 10 minute: 33 second: 12! !

CHChronosDescriptionTest subclass: #CHTimepointDescriptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Tests'!

!CHTimepointDescriptionTest class methodsFor: 'testing' stamp: 'pmm 10/20/2006 22:02'!
isAbstract
	^ false! !

!CHTimepointDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:06'!
actualClass
	^ CHTimepointDescription! !

!CHTimepointDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:06'!
includedInstance
	^ Timepoint year: 1980 month: 6 day: 11 hour: 11 minute: 38 second: 12! !

!CHTimepointDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:06'!
maxInstance
	^ Timepoint year: 1980 month: 6 day: 12 hour: 11 minute: 38 second: 12! !

!CHTimepointDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:06'!
minInstance
	^ Timepoint year: 1980 month: 6 day: 10 hour: 11 minute: 38 second: 12! !

CHChronosDescriptionTest subclass: #CHYearMonthDayDescriptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Tests'!

!CHYearMonthDayDescriptionTest class methodsFor: 'testing' stamp: 'pmm 10/20/2006 22:46'!
isAbstract
	^ false! !

!CHYearMonthDayDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:07'!
actualClass
	^ CHYearMonthDayDescription! !

!CHYearMonthDayDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:07'!
includedInstance
	^ YearMonthDay year: 1980 month: 6  day: 11! !

!CHYearMonthDayDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:07'!
maxInstance
	^ YearMonthDay year: 1980 month: 6 day: 12! !

!CHYearMonthDayDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:37'!
minInstance
	^ YearMonthDay year: 1980 month: 6 day: 10! !

!MAStringWriter methodsFor: '*Magritte-Chronos' stamp: 'pmm 10/20/2006 21:55'!
visitChronosDescription: aChronosDescription
	self object
		printOn: self stream
		using: aChronosDescription printPolicy! !
